// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from plansys2_msgs:msg/DurativeAction.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__MSG__DETAIL__DURATIVE_ACTION__TRAITS_HPP_
#define PLANSYS2_MSGS__MSG__DETAIL__DURATIVE_ACTION__TRAITS_HPP_

#include "plansys2_msgs/msg/detail/durative_action__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'parameters'
#include "plansys2_msgs/msg/detail/param__traits.hpp"
// Member 'at_start_requirements'
// Member 'over_all_requirements'
// Member 'at_end_requirements'
// Member 'at_start_effects'
// Member 'at_end_effects'
#include "plansys2_msgs/msg/detail/tree__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const plansys2_msgs::msg::DurativeAction & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.parameters.size() == 0) {
      out << "parameters: []\n";
    } else {
      out << "parameters:\n";
      for (auto item : msg.parameters) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: at_start_requirements
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "at_start_requirements:\n";
    to_yaml(msg.at_start_requirements, out, indentation + 2);
  }

  // member: over_all_requirements
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "over_all_requirements:\n";
    to_yaml(msg.over_all_requirements, out, indentation + 2);
  }

  // member: at_end_requirements
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "at_end_requirements:\n";
    to_yaml(msg.at_end_requirements, out, indentation + 2);
  }

  // member: at_start_effects
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "at_start_effects:\n";
    to_yaml(msg.at_start_effects, out, indentation + 2);
  }

  // member: at_end_effects
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "at_end_effects:\n";
    to_yaml(msg.at_end_effects, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const plansys2_msgs::msg::DurativeAction & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<plansys2_msgs::msg::DurativeAction>()
{
  return "plansys2_msgs::msg::DurativeAction";
}

template<>
inline const char * name<plansys2_msgs::msg::DurativeAction>()
{
  return "plansys2_msgs/msg/DurativeAction";
}

template<>
struct has_fixed_size<plansys2_msgs::msg::DurativeAction>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<plansys2_msgs::msg::DurativeAction>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<plansys2_msgs::msg::DurativeAction>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PLANSYS2_MSGS__MSG__DETAIL__DURATIVE_ACTION__TRAITS_HPP_
