// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from plansys2_msgs:msg/Param.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__MSG__DETAIL__PARAM__TRAITS_HPP_
#define PLANSYS2_MSGS__MSG__DETAIL__PARAM__TRAITS_HPP_

#include "plansys2_msgs/msg/detail/param__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const plansys2_msgs::msg::Param & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: sub_types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sub_types.size() == 0) {
      out << "sub_types: []\n";
    } else {
      out << "sub_types:\n";
      for (auto item : msg.sub_types) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const plansys2_msgs::msg::Param & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<plansys2_msgs::msg::Param>()
{
  return "plansys2_msgs::msg::Param";
}

template<>
inline const char * name<plansys2_msgs::msg::Param>()
{
  return "plansys2_msgs/msg/Param";
}

template<>
struct has_fixed_size<plansys2_msgs::msg::Param>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<plansys2_msgs::msg::Param>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<plansys2_msgs::msg::Param>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PLANSYS2_MSGS__MSG__DETAIL__PARAM__TRAITS_HPP_
