// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from plansys2_msgs:msg/Knowledge.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__MSG__DETAIL__KNOWLEDGE__TRAITS_HPP_
#define PLANSYS2_MSGS__MSG__DETAIL__KNOWLEDGE__TRAITS_HPP_

#include "plansys2_msgs/msg/detail/knowledge__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const plansys2_msgs::msg::Knowledge & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: instances
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.instances.size() == 0) {
      out << "instances: []\n";
    } else {
      out << "instances:\n";
      for (auto item : msg.instances) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: predicates
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.predicates.size() == 0) {
      out << "predicates: []\n";
    } else {
      out << "predicates:\n";
      for (auto item : msg.predicates) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: functions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.functions.size() == 0) {
      out << "functions: []\n";
    } else {
      out << "functions:\n";
      for (auto item : msg.functions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal: ";
    value_to_yaml(msg.goal, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const plansys2_msgs::msg::Knowledge & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<plansys2_msgs::msg::Knowledge>()
{
  return "plansys2_msgs::msg::Knowledge";
}

template<>
inline const char * name<plansys2_msgs::msg::Knowledge>()
{
  return "plansys2_msgs/msg/Knowledge";
}

template<>
struct has_fixed_size<plansys2_msgs::msg::Knowledge>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<plansys2_msgs::msg::Knowledge>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<plansys2_msgs::msg::Knowledge>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PLANSYS2_MSGS__MSG__DETAIL__KNOWLEDGE__TRAITS_HPP_
